#ifndef _PARTITION_H
#define _PARTITION_H

#define DIR_PROC_IDE		"/proc/ide/"
#define DIR_PROC_SCSI		"/proc/scsi/"

#ifdef TEST
#define FILE_PROC_SCSI		"data/proc-scsi.txt"
#else
#define FILE_PROC_SCSI	"/proc/scsi/scsi"
#endif

#define FILE_ERRORLOG		"/dev/null"

#define TEMPFILE_PARTITIONS 	"/tmp/partitions.tmp"

// Media Types
#define MEDIA_DISK		"disk"
#define MEDIA_PARTITION		"Partition"

// FS Types
#define FS_ISO			"iso9660"
#define FS_EXT2			"ext2"
#define FS_SWAP			"swap"
#define FS_VFAT			"vfat"
#define FS_NONE			"none"

typedef struct stPartition TPartition;

struct stPartition {
  char *name;
  char *model;
  char *media;
  char *fstype;
  long  size;
  TPartition *next;
};

// Extern
extern TPartition *lpPartition;
void AppendPartitionItem();
int probe_eide_disks();
int probe_scsi_disks();
int probe_cfdisk(char *device);

#endif
