#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "ansi.h"
//#include "caronte.h"
//#include "concatenate.h"
#include "file_exists.h"
#include "partition.h"
#include "read_line.h"
#include "runcommand.h"


int probe_cfdisk(char *device) {
  FILE *fd = NULL;
  FILE *fdnull = NULL;
  char *lpaopt[7];
  int   lnum = 0;
  char *tempstr = NULL;
  char *tempdata = NULL;
  tempstr  = calloc( 256, sizeof(char) );
  tempdata = calloc( 256, sizeof(char) );

  // Look up Partitions using cfdisk
  unlink(TEMPFILE_PARTITIONS);
  lpaopt[0] = "cfdisk";
  lpaopt[1] = "-P";	    
  lpaopt[2] = "s";
  lpaopt[3] = lpPartition->name;
  lpaopt[4] = 0;

  fd = fopen(TEMPFILE_PARTITIONS, "w");
  if (fd==NULL) {
    printERROR("Impossibile aprire %s in scrittura !\n", TEMPFILE_PARTITIONS);
    normal_color();
    return 1;
  }

  fdnull = fopen(FILE_ERRORLOG, "w");
  if (fdnull==NULL) {
    printERROR("Impossibile aprire %s in scrittura !\n", FILE_ERRORLOG);
    normal_color();
    return 1;
  }
  
  if ( 0 != runcommand( lpaopt, 0, fileno(fd), fileno(fdnull) )){
//  if ( 0 != runcommand( lpaopt, 0, fileno(fd), -1 )){
    fclose(fd);
    fclose(fdnull);
    printERROR("Impossibile eseguire cfdisk %s !\n", lpPartition->name );
    normal_color();
    return 1;
  }
  
  fd = freopen(TEMPFILE_PARTITIONS,"r",fd);
  if (fd==NULL) {
    printERROR("Impossibile aprire file %s in lettura\n", TEMPFILE_PARTITIONS );
    normal_color();
    return 1;
  }

  while ( ! feof(fd) ) {
    read_line(fd,tempstr);
    if ( (tempstr[1]<'0') || (tempstr[1]>'9') ) continue;
    //printf(">%s\n", tempstr);
    // --- Decode Partition Data ---
    // Get Partition Name
    strncpy(tempdata, tempstr, 2);
    tempdata[2]=0;
    lnum = atol(tempdata);
    if ((lnum<=0)||(lnum>20)) {
      printWARNING("Numero di partizione errato (%i) mentre decifravo la riga %s\n", lnum, tempstr);
      normal_color();
      continue;	
    }
    AppendPartitionItem();
    lpPartition->name = calloc( strlen(lpaopt[3]) + 3, sizeof(char) );
    sprintf( lpPartition->name, "%s%i", lpaopt[3], lnum );
    //printf("New partition = %s \n", lpPartition->name );
    // Calcolo dimensione
    strncpy(tempdata, tempstr+37, 8);
    tempdata[8]=0;
    lpPartition->size = atol(tempdata);
    //printf("Nuova dimensione #%s# = %i\n", tempdata, lnum);
    // Calcolo Nome Modello
    lpPartition->model = strdup("Partizione di 9999999999 KB");
    sprintf( lpPartition->model, "Partizione di %10li KB", lpPartition->size );
    //printf("%s\n", lpPartition->model );
    // Calcolo Media Type
    lpPartition->media = MEDIA_PARTITION;
    // Calcolo FS Type
    if ( NULL != strstr(tempstr+47,"Linux Swap")) lpPartition->fstype=FS_SWAP;
    else
    if ( NULL != strstr(tempstr+47,"Linux swap")) lpPartition->fstype=FS_SWAP;
    else
    if ( NULL != strstr(tempstr+47,"Linux extended")) lpPartition->fstype=FS_NONE;
    else
    if ( NULL != strstr(tempstr+47,"Linux ")) lpPartition->fstype=FS_EXT2;
    else
    if ( NULL != strstr(tempstr+47,"Win95 Extended")) lpPartition->fstype=FS_NONE;
    else
    if ( NULL != strstr(tempstr+47,"DOS")) lpPartition->fstype=FS_VFAT;
    else
    if ( NULL != strstr(tempstr+47,"Win95 FAT")) lpPartition->fstype=FS_VFAT;
    else
    if ( NULL != strstr(tempstr+47,"FAT")) lpPartition->fstype=FS_VFAT;
    else
    lpPartition->fstype=FS_NONE;
    //printf("fstype = %s \n", lpPartition->fstype );
    //Print Row
    printf(" %-10s  %-30s  %-15s %s\n", lpPartition->name, lpPartition->model, lpPartition->media, lpPartition->fstype );
  }
  fclose(fd);
  fclose(fdnull);
  return 0;
}
