#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ansi.h"
#include "caronte.h"
#include "concatenate.h"
#include "file_exists.h"
#include "partition.h"
#include "read_line.h"
#include "runcommand.h"


int probe_eide_disks() {
  DIR *lpdir = NULL;
  FILE *fd = NULL;
  struct dirent *lpdirent = NULL;
  char *tempstr = NULL;
  char *tempdata = NULL;
  tempstr  = calloc( 256, sizeof(char) );
  tempdata = calloc( 256, sizeof(char) );
  
  if ( 0 != file_exists(DIR_PROC_IDE) ) {
    printERROR("Directory %s inesistente !\n", DIR_PROC_IDE );
    normal_color();
    return 1;
  }

  lpdir = opendir(DIR_PROC_IDE);
  if (lpdir==NULL) {    
    printERROR("Impossibile aprire directory %s !\n", DIR_PROC_IDE );
    normal_color();
    return 1;
  }

  lpdirent = readdir(lpdir);
  while (lpdirent!=NULL) {
    // Cerca i file con maschera 'hd*'
    if ( 0 == strncmp(lpdirent->d_name, "hd", 2 ) ) {
      // Alloca memoria per nuova periferica
      //printf("trovato= %s \n", lpdirent->d_name );
      AppendPartitionItem();
      // Assegna nome device
      lpPartition->name = concatenate( "/dev/", lpdirent->d_name );
      // Lettura Modello periferica
      sprintf(tempstr, "%s/%s/model", DIR_PROC_IDE, lpdirent->d_name );
      if ( 0 != file_exists(tempstr) ) {
        printERROR("Impossibile aprire file %s\n", tempstr);
	normal_color();
        return 1;
      }	
      fd = fopen(tempstr,"r");
      if (fd!=NULL) {
        read_line(fd, tempstr);
        fclose(fd);
        lpPartition->model = strdup(tempstr);
      } else {
        lpPartition->model = "Device sconosciuto";
      }
      //printf("Model= %s\n", lpPartition->model );
	  
      // Lettura Media periferica
      sprintf(tempstr, "%s/%s/media", DIR_PROC_IDE, lpdirent->d_name );
      if ( 0 == file_exists(tempstr) ) {
        fd = fopen(tempstr,"r");
        if (fd==NULL) {
          printERROR("Impossibile aprire file %s\n", tempstr);
	  normal_color();
          return 1;
        }
        read_line(fd, tempstr);
        fclose(fd);
        lpPartition->media = strdup(tempstr);
      } else {
	lpPartition->media = "Media sconosciuto";
      }
      //printf("Media= %s\n", lpPartition->media );

      // Se e' un disco stampa subito i dati altrimenti
      // ricerca le partizioni
      if ( 0 != strcmp(lpPartition->media,MEDIA_DISK) ) {
        lpPartition->fstype = FS_ISO;
	printf(" %-10s  %-30s  %-15s %s\n", lpPartition->name, "Lettore CD-ROM ATAPI-EIDE", "cdrom", lpPartition->fstype );
      }else{
        printf(" %-10s  %-30s  %-15s\n", lpPartition->name, lpPartition->model, "Hard Disk" );
        probe_cfdisk(lpPartition->name);
      }
      // Next dirent	  
    }
    lpdirent = readdir(lpdir);
  }
  closedir(lpdir);
  return 0;
}
