#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "ansi.h"
#include "common_errors.h"
#include "parse_info.h"
#include "parse_options.h"
#include "read_line.h"
#include "runcommand.h"


// Elimina tutti i pacchetti secondo il file dei conflitti
int check_conflicts(char *infofile, TSetupOptions *lpopt ){
  char line_buffer[256];
  FILE *fd;
  DIR *lpdir;
  struct dirent *lpstdirent;
  char cmdline[256];
  int retval;
    
  // Apre il file CONFLICTS
  fd = fopen(infofile, "r");
  if (fd == NULL) {
    printWARNING("Il file %s non esiste, i conflitti non verranno gestiti !\n", infofile );
    normal_color();
    return ERRORE_FORMATO;
  }
  
  // Parsing
  line_buffer[0]=0;
  while ( ! feof(fd) ) {
    if ( 0 == read_line(fd,line_buffer) ) continue;
    // In base al nome del conflitto
    // cerca tutti i pacchetti installati da rimuovere
    //printf("Conflitto con %s \n", line_buffer );
    lpdir = opendir( lpopt->spoolroot );
    if (lpdir!=NULL) {
      lpstdirent = readdir(lpdir);
      while (lpstdirent!=NULL) {    
	//printf("Trovato: %s \n", lpstdirent->d_name);
	if ( 0 == strncmp(lpstdirent->d_name, line_buffer, strlen(line_buffer)) ) {
	  printTITLE("Rimuovo il pacchetto in conflitto: %s \n",lpstdirent->d_name);
	  normal_color();
	  sprintf(cmdline, "setup --remove --no-header %s %s", lpstdirent->d_name, lpopt->targetdir );
	  printf("- Eseguo: %s\n", cmdline);
	  // Questa system e' ammessa !
	  //retval = system(cmdline);
	  retval = runshell(cmdline);
	  chdir(lpopt->targetdir);
	  printf("- Ritorno = %i \n", retval );
	}
	lpstdirent = readdir(lpdir);
      }
      closedir(lpdir);
    }
    // Next Line  
  }
  fclose(fd);
  //printf("- Parsing completed !\n");
  return 0;
}
