#include <stdio.h>
#include <string.h>

#include "ansi.h"
#include "file_exists.h"
#include "parse_options.h"
#include "read_line.h"
#include "setup_main.h"

// Cerca un icona gnome nel file di MANIFEST, se la trova
// tocca il file run.install-menu
int check_gnome_icon(TSetupOptions *lpopt) {
  char sourcefile[256], line_buffer[256];
  FILE *fd;

  // Se il flag gia' esiste salta il controllo
  sprintf( sourcefile, "%s/run.install-menu", lpopt->spoolroot );
  if ( 0 == file_exists(sourcefile) ) return 0;
    
  // Apre il MANIFEST
  if ( lpopt->action == ACTION_RESTORE ) return 0;
  sprintf(sourcefile, "%s/install/MANIFEST", lpopt->targetdir );
  fd = fopen(sourcefile,"r");
  if (fd==NULL) {
    printERROR("check_gnome_icon: impossibile aprire %s", sourcefile);
    normal_color();
    return -1;
  }

  // Cerca la stringa
  while ( ! feof(fd) ) {
    if ( 0 == read_line(fd,line_buffer) ) continue;
    if ( NULL != strstr( line_buffer, "usr/share/gnome/apps/" ) ) {
      fclose(fd);
      // Touch file and return
      sprintf( sourcefile, "%s/run.install-menu", lpopt->spoolroot );
      fd = fopen(sourcefile,"w");
      if (fd==NULL) {
        printERROR("check_gnome_icon: impossibile creare %s", sourcefile);
	normal_color();
        return -1;
      }
      fclose(fd);
      printSUCCESS("- i menu dei window-manager verrano rigenerati\n");
      normal_color();
      return 0;
    }
  }
  return 0;
}
