#include <stdio.h>

#include "ansi.h"
#include "common_errors.h"
#include "file_exists.h"
#include "setup_main.h"
#include "parse_options.h"


// Controlla s il pacchetto e' gia installato
// richiede il forcing dell'installazione
int check_installed(TSetupOptions *lpopt) {
  int already_installed;
  char c;
  
  // Controllo Pacchetto Installato
  already_installed = file_exists( lpopt->spooldir );
  //printf("Already installed ? %i \n", already_installed );

  // In caso e' installato ...
  if (already_installed == 0 ) {
    if (lpopt->action == ACTION_INSTALL) {
      if (lpopt->force==1) {
        printWARNING("- Il pacchetto e' gia' installato, forzo l'installazione.\n");
	normal_color();
	return 0;
      }
      if (lpopt->relaxed==1) {
        printWARNING("Il pacchetto e' gia' installato, rinuncio all'installazione.\n");
	normal_color();
	return ERRORE_ESISTENTE;
      }
      // Chiede conferma installazione pacchetto
      printNOTICE("- Il pacchetto %s e' gia' installato, ... \n", lpopt->fullname );
      normal_color(); 
      c=' ';
      while ( c!='S' && c!='s'&& c!='N' && c!='n') {
        printf("  desideri re-installarlo (s/n) ? ");
        scanf("%1c", &c);
      }
      if ( c=='N' || c=='n') {
        printERROR("Installazione annullata dall'utente\n");
	normal_color();
        return ERRORE_IGNORABILE;
      }
      return 0;
    }
  } else {
    if (lpopt->action != ACTION_INSTALL) {
      printERROR("Spiacente, non si puo' aggiornare o ripristinare un pacchetto non installato.\n");
      normal_color(); 
      return ERRORE_ESISTENTE;
    }  
  }
  return 0;
}
