#include <stdio.h>
#include <stdlib.h>

#include "file_exists.h"
#include "parse_options.h"
#include "read_line.h"
#include "setup_main.h"

// Accoda le dipendenza da /install/REQUEST in $SPOOL/DEPS

int check_request(TSetupOptions *lpopt) {
  char sourcefile[256], targetfile[256], line_buffer[256];  
  char *s = NULL;
  FILE *fds = NULL;
  FILE *fdt = NULL;

  // In caso di restore lascia stare questa operazione  
  if ( lpopt->action == ACTION_RESTORE ) return 0;
  // Controlla se il file esiste, altrimenti ignora l'operazione
  sprintf( sourcefile, "%s/install/REQUEST", lpopt->targetdir );
  if ( 0 != file_exists(sourcefile) ) return 0;
  // Apre il file REQUEST  
  if (lpopt->verbose > 0 ) printf( "- Schedulazione delle dipendenze obbligatiorie\n" );
  fds = fopen(sourcefile,"r");
  if (fds == NULL) {
    printf("check_request: impossibile aprire REQUEST %s\n", sourcefile );
    return -1;
  }
  // Apre in append il file DEPS
  sprintf( targetfile, "%s/%s/DEPS", lpopt->targetdir, SETUP_SPOOLROOT );
  fdt = fopen(targetfile,"a");
  if (fdt == NULL) {
    printf("check_request: impossibile aprire %s\n", targetfile );
    fclose(fdt);
    return -1;
  }
  // Trasporta le dipendenze  
  while( ! feof(fds) ) {
    if ( 0 == read_line(fds, line_buffer) ) continue;
    s= line_buffer;
    // Drop line leading with comment
    while ( (s[0]==' ') || (s[0]==9) ) s++;
    if (s[0]=='#' || s[0]==0 ) continue;
    //printf("Scrivo %s nel depfile\n", s );
    fwrite( s, 1, strlen(s), fdt );
    fwrite( "\n", 1, 1, fdt );
  }
  fclose(fds);
  fclose(fdt);
  return 0;
}
