#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ansi.h"
#include "parse_request.h"

// Ritorna il token successivo sulla riga separa ta TABS o spazi
char *deptoken(char **s) {
  char *r;
  int i;
  // Drop leading whitespaces
  while ( ((*s)[0]==' ') || ((*s)[0]=='\t') ) {
    (*s)++;
  }
  // Find end of token
  i=0;
  while ( ((*s)[i]!=' ') && ((*s)[i]!='\t') && ((*s)[i]!=0) ) {
    //printf("%i - %c\n", i, (*s)[i] );
    i++;
  }
  if ( (*s)[i] == 0 ) {
    // Duplicate token
    r = strdup(*s);
    // Advance string pointer
    (*s)[0]=0;
  } else {  
    // Terminate string
    (*s)[i]=0;
    // Duplicate token
    r = strdup(*s);
    // Advance string pointer
    *s = (*s) + i + 1;
  }
  // return
  //printf("Token: %s   Rimasto: %s\n", r, *s);
  return r;
}


// Dalla lista delle dipendenze lette dal file DEPS
// decodifica la linea di testo contenente la dipendenza
// assegnando ai vari campi della struttura i giusti valori
TDepList *decode_request(TDepList *first) {
  TDepList *link, *temp;
  char *s;
  //int count;
  
  // Conta dipendenze 
  //link = first;
  //count = 0;
  //while (link!=NULL) { link=link->next; count++; }
  //printf("- nr. %i dipendenze da elaborare\n", count );

  // Decodifica campi
  link = first;
  while (link!=NULL) {
    //printf("decode_request.c: %s\n", link->text);
    //printf("                : %s\n", link->next->text);

    s = strdup(link->text);
    link->category = deptoken(&s);
    link->pkgname  = deptoken(&s);
    link->libname  = deptoken(&s);
    link->pkgmin   = deptoken(&s);
    link->libmin   = deptoken(&s);
    temp=link;
    link=link->next;
    if (
      ( temp->category == NULL) || (temp->category[0] == 0) ||
      ( temp->pkgname  == NULL) || (temp->pkgname[0] == 0) ||
      ( temp->libname  == NULL) || (temp->libname[0] == 0)
    ) {
      printWARNING("Formato dipendenza non valido: %s\n", temp->text);
      normal_color();
      if (temp->prev == NULL) {
        //printf("- rimuovo dipendenza dalla testa \n");
        first=link;
	if (first != NULL) first->prev=NULL;
	free(temp);
      } else {
        //printf("- rimuovo dipendenza dal mezzo \n");
        temp->prev->next = link;
	if (link != NULL ) link->prev = temp->prev;
	free(temp);
      }
    }
  }  
  // Ritorna Puntatore alla prima dep
  return first;
}
