#include <assert.h>
#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "concatenate.h"
#include "check_version.h"

// Find into a directory if there is a package matching the specified
// soname-major and minor version (thru check_version)
// and return its fullpath
char *find_in_dir(char *finddir, int recurse, char *major, char *minor ) {
  DIR *lpdir;
  struct dirent *lpstdirent;
  char *retstr, *tempstr;
  
  tempstr = calloc( 256, sizeof(char));
  assert(tempstr!=NULL);
  
  lpdir = opendir( finddir );
  if (lpdir!=NULL) {
    lpstdirent = readdir(lpdir);
    while (lpstdirent!=NULL) {    
      // Match ?
      if ( 0 == strncmp(lpstdirent->d_name, major, strlen(major) )) {
        if ( strlen(minor) > 0 ) {
          // Confronto del minor number
          sprintf( tempstr, "%s.%s", major, minor );
          if ( check_version( lpstdirent->d_name, tempstr ) >= 0 ) {
    	    return concatenate(finddir, lpstdirent->d_name );
          }
        } else {
          return concatenate(finddir, lpstdirent->d_name );
        }
      }
      // Recurse subdir
      if ((recurse==1) && (lpstdirent->d_name[0] != '.')) {
        sprintf(tempstr, "%s/%s", finddir, lpstdirent->d_name);
	//printf("Discendo in: %s\n", tempstr);
	retstr = find_in_dir(tempstr,0,major,minor);
	//printf("Stringa di ritorno: %s\n", retstr);
	if (retstr!=NULL) return retstr;
      }
      // Next
      lpstdirent = readdir(lpdir);
    }
    closedir(lpdir);
  }
  return NULL;
}



// Try to guess where is a package to be installed due to an unresolved
// dependencie
char *find_package(char *startdir, char *category, char *major, char *minor ) {
  char *s, *pkgdir, *depdir;
  int l;
  depdir = calloc( 256, sizeof(char));
    
  //printf("Starting dir = %s \n", startdir );
  // Controlla se la main dir include packages
  s = strstr( startdir, "/packages/" );
  if ( s != NULL ) {
    //printf("Trovato packages = %s \n", s );
    s = s + strlen("/packages/");
    //printf("Avanzo packages = %s \n", s );
    l = s - startdir;
    //printf("Lunghezza = %i \n", l );
    pkgdir = strdup(startdir);
    pkgdir[l]=0;
    //printf("Pkgdir = %s \n", pkgdir );
    // Abbiamo trovato la directory dei pacchetti
    // Aggiungi il pacchetto della dipendenza e prova a cercare li'
    sprintf(depdir,"%s%s/", pkgdir, category);
    //printf("find in category = %s ==> %s \n", category, depdir );
    s = find_in_dir( depdir, 0, major, minor);
    //printf("find_in_dir = %s \n", s );
    if ( s != NULL ) return s;
    // Non trovato cerca in tutte le categorie
    //printf("find recursive in = %s \n", pkgdir );
    s = find_in_dir( pkgdir, 1, major, minor);
    return s;
  }
  // Cerca nella directory origine
  //printf("find in source category = %s ==> %s \n", category, startdir );
  s = find_in_dir( startdir, 1, major, minor );
  //printf("find_in_dir = %s \n", s );    
  return s;
}