#include <dirent.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ansi.h"
#include "check_version.h"
#include "concatenate.h"
#include "dirpath.h"
#include "find_package.h"
#include "parse_options.h"
#include "parse_request.h"
#include "runcommand.h"
#include "setup_finalize.h"

#define MAX_SEARCHDIR 5

// Remove Link
TDepList* remove_dep(TDepList* main, TDepList* link) {
  TDepList* old;
  if (link==main) {
    //printf("remove_dep: primo elemento \n");
    link->next->prev = NULL;
    old=link;
    link=link->next;
    free(old);
    return link;
  }
  //printf("remove_dep: centrale \n");  
  if (link->next != NULL) link->next->prev = link->prev;
  if (link->prev != NULL) link->prev->next = link->next;
  old=link;
  link=link->next;
  free(old);
  return main;    
}



// Controlla ed installa tutte le dipendenze necessarie
TDepList *install_request(TSetupOptions *lpopt, TDepList *first) {
  TDepList *link, *miss_first, *miss_current;
  int count;
  DIR *lpdir;
  struct dirent *lpstdirent;
  char *searchdir[MAX_SEARCHDIR] = { "/usr/lib/", "/usr/X11R6/lib/", "/usr/local/lib/", "/lib/", "" };
  int trovato=0, i=0, startsearch=0, endsearch=0, retval=0;
  char* searchname;
  char tempstr[255], *pkgtemp;
  int lenname;
  
  // Lista delle dipendenze non risolte
  miss_first = NULL;
  miss_current = NULL;
    
  // Conta dipendenze
  link = first;
  count = 0;
  while (link!=NULL) { link=link->next; count++; }
  printf("- nr. %i dipendenze da controllare\n", count );

  // Decodifica campi
  for ( link=first; link!=NULL; link=link->next ) {
    trovato=0;  
    // Controlla se la maschera del pacchetto e' presente
    //printf("Controllo richiesta pacchetto: %s \n", link->pkgname );
    lpdir = opendir( lpopt->spoolroot );
    if (lpdir!=NULL) {
      lpstdirent = readdir(lpdir);
      while (lpstdirent!=NULL) {    
	if ( 0 == strncmp(lpstdirent->d_name, link->pkgname, strlen(link->pkgname) )) {
	  if ( strlen(link->pkgmin) > 0 ) {
	    // Confronto del minor number
	    sprintf( tempstr, "%s.%s", link->pkgname, link->pkgmin );
  	    if ( check_version( lpstdirent->d_name, tempstr ) >= 0 ) {
    	      printf("- Dip. da pacc. %s risolta da %s \n", tempstr, lpstdirent->d_name );
	      trovato=1;
	      break;	    
	    }
	  } else {
  	    printf("- Dip. da pacc. %s risolta da %s \n", link->pkgname, lpstdirent->d_name );
	    trovato=1;
	    break;
	  }
	}
	lpstdirent = readdir(lpdir);
      }
      closedir(lpdir);
      if (trovato==1) { 
        first = remove_dep(first,link); 
	continue;
      }
    }
    // Pacchetto richiesto non presente, allora ...
    // Controlla se la maschera del file/libreria e' presente
    //printf("Controllo richiesta file: %s \n", link->libname );
    if ( link->libname[0] == '/' ) {
      // Controllo assoluto
      startsearch=MAX_SEARCHDIR-1;
      endsearch=MAX_SEARCHDIR;
      searchdir[MAX_SEARCHDIR-1] = dirpath(link->libname);
      searchname=basename(link->libname);
    } else {
      startsearch=0;
      endsearch=MAX_SEARCHDIR-1;
      searchdir[MAX_SEARCHDIR-1] = NULL;
      searchname=link->libname;
    }
    lenname = strlen(searchname);
    
    // Controllo Directory
    for (i=startsearch; i<endsearch; i++) {
      //printf("Controllo nr. %i in %s \n", i, searchdir[i] );
      lpdir = opendir( concatenate(lpopt->targetdir, searchdir[i] ));
      if (lpdir!=NULL) {
        lpstdirent = readdir(lpdir);
        while (lpstdirent!=NULL) {    
          if ( 0 == strncmp(lpstdirent->d_name, searchname, lenname )) {
  	    if ( strlen(link->libmin) > 0 ) {
	      // Confronto del minor number
	      sprintf( tempstr, "%s.%s", link->libname, link->libmin );
  	      if ( check_version( lpstdirent->d_name, tempstr ) >= 0 ) {
    	        printf("- Dip. dal file %s risolta da %s\n", tempstr, lpstdirent->d_name );
	        trovato=1;
	        break;	    
	      }
            } else {
              printf("- Dip. dal file %s risolta da %s%s%s \n", searchname, lpopt->targetdir, searchdir[i], lpstdirent->d_name);
	      trovato=1;
	      break;
	    }
	  }
	  lpstdirent = readdir(lpdir);
	}
        closedir(lpdir);
        if (trovato==1) break;
      }
    }
    if (trovato==1) { 
      first = remove_dep(first,link); 
      continue;
    }

    // Dipendenza non trovata ? 
    // Gasp, ora occorre installarla !
    pkgtemp = find_package( lpopt->sourcedir, link->category, link->pkgname, link->pkgmin );
    if ( NULL != pkgtemp ) {
      printf("- Trovato pacchetto %s che soddisfa %s min. %s \n", pkgtemp, link->pkgname, link->pkgmin ); 
      sprintf(tempstr, "setup --install  %s  %s --no-header", pkgtemp, lpopt->targetdir );
      printf("Eseguo: %s \n", tempstr); 
      retval = runshell(tempstr);
      printf("Return code = %i \n", retval);
      if ( retval == 0 ) {
        giAlmostOne++; // Increase the number of packege installed into the main loop
        first = remove_dep(first,link);
	continue;
      }
    }
    // Pacchetto non trovato o installazione fallita
    // allora non rimuovere dipendenza
    // Mette il pacchetto nella nuova lista
    printf("- Impossibile soddisfare %s min. %s \n", link->pkgname, link->pkgmin );
  // end for    
  }
  return first;
}
