#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ansi.h"
#include "deltree.h"
#include "file_exists.h"
#include "parse_options.h"
#include "parse_request.h"
#include "read_line.h"
#include "setup.h"
#include "setup_main.h"

// per setup--finalize, analizza il file DEPS creando la lista
// delle dipendenze in memoria, quindi elimina il file
TDepList *parse_request(TSetupOptions *lpopt) {
  char sourcefile[256], line_buffer[256];  
  char *s=NULL;
  FILE *fds=NULL;
  TDepList *firstDep=NULL, *link=NULL, *newlink=NULL;
  int diff;
  
  sprintf( sourcefile, "%s/%s/DEPS", lpopt->targetdir, SETUP_SPOOLROOT );
  fds = fopen(sourcefile,"r");
  if (fds == NULL) {
    printf("parse_request: impossibile aprire DEPS %s\n", sourcefile );
    return NULL;
  }

  while( ! feof(fds) ) {
    if ( 0 == read_line(fds, line_buffer) ) continue;
    s= line_buffer;
    // Drop line leading with comment
    while ( (s[0]==' ') || (s[0]==9) ) s++;
    if (s[0]=='#' || s[0]==0 ) continue;
    //printf("Lettura dipendenza: %s \n",s);
    if (firstDep==NULL) {
      firstDep = calloc( 1, sizeof(TDepList) );
      firstDep->text = strdup(s);
      link = firstDep;
      //printf("Aggiunto primo elemento: %s \n", s);
    } else {
      for ( link=firstDep; link!=NULL; link=link->next ) {
        diff = strcmp( link->text, s );
	if ( diff == 0 ) {
	  //printf("Dipendenza pre-esistente: %s \n", s);
	  break;
	}
	if ( diff<0 ) {
	  newlink = calloc( 1, sizeof(TDepList) );
          newlink->text = strdup(s);
	  newlink->prev = link->prev;
	  newlink->next = link;
	  link->prev    = newlink;
	  if (newlink->prev != NULL) newlink->prev->next=newlink;
	  if ( link == firstDep ) {
	    firstDep=newlink;
	    //printf("Aggiunta %s in testa al posto di %s \n", s, link->text);
	  } else {
	    //printf("Aggiunta %s prima di %s\n", s, link->text);
	  }
	  break;
	}
	if (link->next == NULL) {
	  newlink = calloc( 1, sizeof(TDepList) );
          newlink->text = strdup(s);
	  newlink->prev = link;
	  link->next = newlink;
	  //printf("Aggiunta %s in coda\n", s );
	  break;
	}
      }
    }    
  }
  fclose(fds);
  //printf("ritorno = %s \n\n", firstDep->text );
  deltree(sourcefile);
  return firstDep;
}
