#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ansi.h"
#include "deltree.h"
#include "file_exists.h"
#include "parse_options.h"
#include "parse_request.h"
#include "read_line.h"
#include "setup.h"
#include "setup_main.h"

// per setup--finalize, analizza il file DEPS creando la lista
// delle dipendenze in memoria, quindi elimina il file
TDepList *rewrite_request(TSetupOptions *lpopt, TDepList *first) {
  char sourcefile[256];
  FILE *fd;
  TDepList *link, *old;
  
  sprintf( sourcefile, "%s/%s/DEPS", lpopt->targetdir, SETUP_SPOOLROOT );
  fd = fopen(sourcefile,"a");
  if (fd == NULL) {
    printERROR("parse_request: impossibile aprire DEPS in accodamento %s\n", sourcefile );
    normal_color();
    return NULL;
  }
  // Scrive deps
  link = first;
  while(link!=NULL) {
    fprintf(fd, "%s\t%s\t%s\t%s\t%s\n", link->category, link->pkgname, 
      link->libname, link->pkgmin, link->libmin
    );
    old=link;
    link=link->next;
    free(old);
  }
  fclose(fd);
  return NULL;
}
