#include <stdio.h>

#include "ansi.h"
#include "decode_request.h"
#include "file_exists.h"
#include "install_request.h"
#include "parse_request.h"
#include "parse_options.h"
#include "rewrite_request.h"
#include "setup_main.h"

int giAlmostOne;

int setup_finalize(TSetupOptions *lpopt) {
  char sourcefile[256];
  TDepList *firstItem;
  
  sprintf( sourcefile, "%s/%s/DEPS", lpopt->targetdir, SETUP_SPOOLROOT );
  if ( 0 != file_exists(sourcefile)) return 0;
  printTITLE( "Analisi delle dipendenze\n" );
  normal_color();
  
  // Almost one
  giAlmostOne=1;
  while ( giAlmostOne > 0 ) {
    giAlmostOne = 0;
    // Legge le dipendenze
    firstItem = parse_request(lpopt);
    if (firstItem==NULL) return -1;
    // Decodifica la lista
    firstItem = decode_request(firstItem);
    if (firstItem==NULL) return 0;
    // Installa le dipendenze
    firstItem = install_request(lpopt, firstItem);
    // Riscrive il file delle dipendenze
    firstItem = rewrite_request(lpopt, firstItem);
  }

  // Run --post-install in interactive mode
  if ( lpopt->interactive == 1 ) {
    lpopt->noheader = 1;
    lpopt->action = ACTION_POSTINSTALL;
    return setup_post_install( lpopt );
  }  
  return 0;
}
