#include <dirent.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "ansi.h"
#include "common_errors.h"
#include "file_exists.h"
#include "parse_options.h"
#include "runcommand.h"
#include "setup.h"
#include "setup_main.h"

int setup_post_install(TSetupOptions *lpopt) {
  DIR *lpdir = NULL;
  struct dirent *lpdirent = NULL;
  int retval=0;
  int post_ran=0;
  char tempstr[255];
  char *pattern = NULL;
  char c = ' ';
  int l=0;
  char *s = NULL;
        
  // Open pkg's DB
  lpdir = opendir(SETUP_SPOOLROOT);
  if ( lpdir == NULL ) {
    printERROR("Impossibile aprire %s\n", SETUP_SPOOLROOT);
    normal_color();
    return ERRORE_IO;
  }
  
  // Select matching pattern
  if (lpopt->action == ACTION_POSTINSTALL) {
    pattern = ".post-install";
  } else {
    pattern = ".x-post-install";
  }
  
  // Check dir
  lpdirent = readdir(lpdir);
  while (lpdirent != NULL) {
    // Check pattern
    s = strstr(lpdirent->d_name,pattern);
    if (s!=NULL) {
      // Check if package is installed
      strcpy(tempstr,SETUP_SPOOLROOT);
      l= strlen(lpdirent->d_name) - strlen(s);
      strncpy( tempstr+strlen(SETUP_SPOOLROOT), lpdirent->d_name, l );
      tempstr[ strlen(SETUP_SPOOLROOT) + l ]=0;
      //printf("Nome categoria da verificare = %s \n", tempstr);
      if ( 0 != file_exists(tempstr) ) {
        printWARNING("Il pacchetto e' stato rimosso, inutile configurare ...\n");
	normal_color();
        sprintf(tempstr, "%s/%s", SETUP_SPOOLROOT, lpdirent->d_name );
        unlink(tempstr);
      } else {
        // Run script thru' shell
        if (lpopt->action == ACTION_POSTINSTALL) {
          printf("\n[%s %s %s]---------------------------------------------\n", FG_GREEN, lpdirent->d_name, FG_WHITE );
        } else {
          printf("\n[ %s ]---------------------------------------------\n", lpdirent->d_name );
        }
        sprintf(tempstr, "%s/%s", SETUP_SPOOLROOT, lpdirent->d_name );
        retval = runshell( tempstr );
        if (retval==0) {
          unlink(tempstr);
          sleep(1);
          post_ran=1;
        } else {
          printERROR("Errore (%i) durante la configurazione del pacchetto !\n", retval);
          normal_color();
          if (lpopt->relaxed>0) {
            sleep(1);
          } else {		
            printf("  Premi INVIO per continuare");
	    c = getchar();
          }
        }
      }
    }
    // Next
    lpdirent = readdir(lpdir);
  }
  //
  if (post_ran>0) {
    printf("Aggiornamento librerie dinamiche ...");
    runshell("ldconfig");
    printf("Ok\n");
  }
  return 0;
}
