#include <sys/stat.h>
#include <dirent.h>
#include <stdio.h>
#include <unistd.h>

// Elimina tutto quello che c'e' in questo percorso, da 1 singolo file
// all'interno FS :-) ... take care !

int deltree(char *path) {
  struct stat lpststat;
  struct dirent *lpstdirent = NULL;
  DIR *lpstdir = NULL;
  int oldval = 0;
  int retval = 0;
  char tempdir[256];
    
  // Return if not exists
  if ( 0 != lstat(path, &lpststat)) return 0;
  // Delete everything into a subdirectory
  if (S_ISDIR (lpststat.st_mode)) {
    lpstdir = opendir(path);
    // If dir is not empty then remove it
    if (lpstdir != NULL) {
      lpstdirent = readdir (lpstdir);
      while (lpstdirent != NULL) {
        if (
	  ( strlen(lpstdirent->d_name) >2 ) ||
	  (
	    ( 0 != strcmp(lpstdirent->d_name, ".")) &&
	    ( 0 != strcmp(lpstdirent->d_name, ".."))
	  )
	) {
	  sprintf(tempdir,"%s/%s", path, lpstdirent->d_name);
	  retval += deltree(tempdir);
	}
	lpstdirent = readdir (lpstdir);
       }
       closedir (lpstdir);
     }
     // Remove dir
     oldval = retval;
     retval += rmdir(path);
     if ( retval - oldval != 0 ) {
       printf("deltree: error while removing dir %s\n", path); 
     //} else {
     //  printf("deltree: dir %s has been removed\n", path); 
     }
     // Return the sum of the error codes
     return retval;
  } else {
    retval = unlink (path);
    if (retval!=0) { 
      printf("deltree: error while unlinking file %s\n", path); 
    //} else {
    //  printf("deltree: file %s has been unliked\n", path); 
    }
    return retval;
  }
}
