#include <stdio.h>
#include <unistd.h>

#define MOVE_BUFFER_SIZE	512

// Try to move a single file, first using the rename syscall
// and the copying the file to the target file and unlinking
// the source file.
// Keep out: the target directory should exist
int file_move( char* source, char* target) {
  int readed, writed;
  char buffer[MOVE_BUFFER_SIZE];
  FILE *fds, *fdt;
  
  // Try to rename
  if ( 0 == rename(source,target) ) return 0;
  // Move
  printf("rename: moving %s to %s\n", source, target);
  fds = fopen(source,"r");
  if (fds==NULL) {
    printf("rename: impossibile aprire in lettura %s\n", source);
    return -1;
  }
  fdt = fopen(target,"w");
  if (fds==NULL) {
    printf("rename: impossibile aprire in scrittura %s\n", target);
    fclose(fds);
    return -1;
  }
  while( ! feof(fds) ) {
    readed = fread( buffer, 1, MOVE_BUFFER_SIZE, fds );
    writed = fwrite( buffer, 1, readed, fdt );
    if ( readed != writed ) {
      printf("rename: errore I/O letti %i, scritti %i \n", readed, writed);
      fclose(fds);
      fclose(fdt);
      return -1;
    }
  }
  fclose(fds);
  fclose(fdt);
  printf("rename: tutto OK, unlinking ...");
  return unlink(source);
}
