#include <stdio.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "common_errors.h"
#include "dirpath.h"
#include "file_exists.h"

// same as the shell command: mkdir -P -m
int makedir( char* s, mode_t m ) {
  char *f;

  // Controllo se la directory esiste gia'
  if ( 0 == file_exists(s) ) return 0;

  // Controllo se il padre esiste
  f = dirpath(s);
  if ( 0 != file_exists( f ) ) {
    printf("makedir: %s does not exists !\n", f );
    if ( 0 != makedir( f, m ) ) {
      printf("makedir: error creating %s !\n", f );
      return ERRORE_IO;
    }
  }
  // L'albero del padre e' stato creato, puoi creare la foglia
  printf("makedir: %s does not exists, creating !\n", f );
  return mkdir( s, m );
}
