#include <sys/wait.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#define __USE_GNU
#include <unistd.h>



// Run a command using the shell
int runshell (char *command) {
  int pid, status;
  pid = fork();
  if (pid == -1) return -1;
  if (pid == 0) {
    char *argv[4];
    argv[0] = "sh";
    argv[1] = "-c";
    argv[2] = command;
    argv[3] = 0;
    execve("/bin/sh", argv, environ);
    exit(127);
  }
  do {
    if (waitpid(pid, &status, 0) == -1) {
      if (errno != EINTR) return -1;
    } else {
      return status;
    }
    sleep(1);
  } while(1);
  return -1; // fake the compiler :-)
}


// Run a command (you should specify each options) without
// using the shell, you should open file to redirect the output
int runcommand (char *options[], int fdin, int fdout, int fderr ) {
  int pid, status;
  pid = fork();
  if (pid == -1) return -1;
  if (pid == 0) {

    if (fdin>0) dup2( fdin, STDIN_FILENO ); else
    if (fdin<0) fclose(stdin);    

    if (fdout>0) dup2( fdout, STDOUT_FILENO ); else
    if (fdout<0) fclose(stdout);    

    if (fderr>0) dup2( fderr, STDERR_FILENO ); else
    if (fderr<0) fclose(stderr);

    execvp(options[0], options);
    exit(127);
  }
  do {
    if (waitpid(pid, &status, 0) == -1) {
      if (errno != EINTR) return -1;
    } else {
//      if (fdin!=0) close( fdin );
//      if (fdout!=0) close( fdout );      
      return status;
    }
    sleep(1);
  } while(1);
}
